summaryrefslogtreecommitdiff
path: root/tests
diff options
context:
space:
mode:
authorJim Meyering <meyering@redhat.com>2011-07-25 11:31:01 +0200
committerJim Meyering <meyering@redhat.com>2011-07-25 14:15:44 +0200
commitf28a09810b7dc11261cb43e2a09726caf9a993b7 (patch)
tree5fd2afa981e816f28eaa8aba4a189620a032abfe /tests
parentaeb5222a6d7f7e9be5b737e2dbaf71185a9946db (diff)
downloadcoreutils-f28a09810b7dc11261cb43e2a09726caf9a993b7.tar.xz
cp -up: preserve all hard links
* src/copy.c (copy_internal): With --update (-u), this function would return early once it found that the destination is not older than the source, *without* recording the source-dev/ino--to--dest_name mapping. That mapping is required in order to preserve src hard links in the destination tree, so when using cp with --update and --preserve=links (perhaps via -p or -a), cp could fail to preserve one hard link per inode when at least one of the hard-linked names already exists in the destination tree. Reported by Odd Harry Mannsverk in http://debbugs.gnu.org/8419. * tests/cp/preserve-link: New file. Exercise the flaw/fix. * tests/Makefile.am (TESTS): Add it. * NEWS (Bug fixes): Mention it.
Diffstat (limited to 'tests')
-rw-r--r--tests/Makefile.am1
-rwxr-xr-xtests/cp/preserve-link40
2 files changed, 41 insertions, 0 deletions
diff --git a/tests/Makefile.am b/tests/Makefile.am
index ebd1b1121..0a83dae79 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -341,6 +341,7 @@ TESTS = \
cp/parent-perm-race \
cp/perm \
cp/preserve-2 \
+ cp/preserve-link \
cp/preserve-slink-time \
cp/proc-short-read \
cp/proc-zero-len \
diff --git a/tests/cp/preserve-link b/tests/cp/preserve-link
new file mode 100755
index 000000000..d0da87356
--- /dev/null
+++ b/tests/cp/preserve-link
@@ -0,0 +1,40 @@
+#!/bin/sh
+# Exercise the fix for http://debbugs.gnu.org/8419
+
+# Copyright (C) 2011 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+print_ver_ cp
+
+same_inode()
+{
+ local u v
+ u=$(stat --format %i "$1") &&
+ v=$(stat --format %i "$2") && test "$u" = "$v"
+}
+
+mkdir -p s t/s || framework_failure_
+touch s/f t/s/f || framework_failure_
+ln s/f s/link || framework_failure_
+
+# This must create a hard link, t/s/link, to the existing file, t/s/f.
+# With cp from coreutils-8.12 and prior, it would mistakenly copy
+# the file rather than creating the link.
+cp -au s t || fail=1
+
+same_inode t/s/f t/s/link || fail=1
+
+Exit $fail